package com.example.switchyard.switchyard_example;

import javax.inject.Inject;

import org.switchyard.Exchange;
import org.switchyard.Scope;
import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;

@Service(ValidatorService.class)
public class ValidatorServiceBean implements ValidatorService
{

  @Inject
  @Reference
  private CamelService router;

  @Inject
  Exchange exchange;

  @Override
  public String validateInput(String input)
  {

    // trying to send the original input in it's original non changed form to OtherServiceBean
    exchange.getContext().setProperty("sendme", "original " + input, Scope.MESSAGE);
    System.out.println(( String ) exchange.getContext().getProperty("sendme").getValue());

    /*
     * in our real service here we do some validation of the inbound string to check xml wellformedness and then jaxb
     * transform it, as we need to have control of the output regardless of the binding, so composers etc aren't an
     * option (we use rest, sca and email bindings in the real service).
     */

    MyJavaBean bean = new MyJavaBean();
    bean.setMyData("Translated " + input);
    bean.setMyData2("RouteA");

    MyJavaBean response = router.route(bean);

    return response.getMyData();
  }

}
